C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.



C       This common block contains info about open wave files
C       and buffers in use.

        INTEGER BUFLEN
        INTEGER NBUFS
        PARAMETER (BUFLEN = 8192, NBUFS=10)
        CHARACTER BUF(BUFLEN,NBUFS)
        INTEGER NAMLEN
C       How large file names should we support?
        PARAMETER (NAMLEN = 500)
C       RECORD holds NBUFS columns. Row 1 holds a file unit,
C       row 2 holds a record number. Together, these indicate
C       what is stored in a buffer.
C       EX: RECORD(:,7) = (8, 3) means BUF(:,7)
C       holds record 3 of file unit 8.
        INTEGER RECORD(2,NBUFS)
C       USED(buffer) gives a number indicating what buffer
C       was most recently used. This is used when
C       determining which buffer to discard,
C       ie. discard the buffer that has not been in use
C       for the longest time.
        INTEGER USED(NBUFS)
C       Indicate whether or not a buffer was written to.
        LOGICAL DIRTY(NBUFS)
C       Indicates whether or not a file was written to.
        LOGICAL FILEWR(0:99)
C       NXT holds the next value to use in USED
        INTEGER NXT
C       DESCR is a descriptor table containing info
C       about open wave files. Look at doc/DESCRIPTOR
C       for more info.
        INTEGER NDESCR
        PARAMETER (NDESCR = 9)
        INTEGER DESLEN, DESDAT, DESDLN, DESFMT, DESFLN, DESSAM,
     +  DESCNS, DESRTE, DESBPS
        PARAMETER (DESLEN = 1, DESDAT = 2, DESDLN = 3, DESFMT = 4,
     +  DESFLN = 5, DESSAM = 6, DESCNS = 7, DESRTE = 8, DESBPS = 9)

        INTEGER DESCR(NDESCR,0:99)
C       Indicates whether or not the data subchunk is the last
C       subchunk of file U
        LOGICAL DTLAST(0:99)
C       Indicates whether or not the file length was changed
        LOGICAL CHGWLN(0:99)
C       Indicates whether or not the number of samples has changed
        LOGICAL CHGSAM(0:99)
        COMMON /WAV/ BUF, RECORD, USED, DIRTY, FILEWR, NXT, DESCR,
     +  DTLAST, CHGWLN, CHGSAM
        SAVE /WAV/
