C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C       Function to determine file size by using the
C       GNU extension FSTAT
C       Returns file size, or -1 if file does not exist,
C       or -2 if it's longer than the maximum supported length.

        INTEGER*8 FUNCTION FSIZE(U,FNAME)
          IMPLICIT NONE
          CHARACTER*(*) FNAME
          INTEGER U, IOS
          COMMON /ERR/ IOS
          INTEGER VALUES(13)

          IOS = 0
          OPEN(U, FILE=FNAME, STATUS='OLD', ACCESS='DIRECT',
     +    FORM='UNFORMATTED', RECL=1,IOSTAT=IOS,ERR=99)

          CALL FSTAT(U,VALUES)
          FSIZE = VALUES(8)
         
          IF (FSIZE .EQ. 0) THEN
             FSIZE = -2
          ENDIF
 
          CLOSE(U)
          RETURN
  99      FSIZE = -1
          RETURN
        END
