C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Get N byte integer from file U at index POS, encoded in little endian
C     Sign-extend if SIGNED is true. The integer is returned in NUM.
C     Return .TRUE. on success, .FALSE. on error (eg
C     the position exceeds file length)
C     N must not be larger than the implementation length
C     of the INTEGER type.
      
      LOGICAL FUNCTION GETINT(NUM, U,POS,N,SIGNED)
        INTEGER NUM, U, POS, N, I, BITS
        LOGICAL SIGNED
C       Buffer, assuming integer type is 16 or fewer bytes long.
        CHARACTER TEMP(16)
        INCLUDE "../../common/wav.f"
        LOGICAL GETSTR
        
C       Get the relevant bytes from the file
        GETINT = GETSTR(TEMP,U,POS,N)
        IF (.NOT. GETINT) THEN
          NUM = -1
          RETURN
        ENDIF

        BITS = 8*N
        NUM = 0

C       The integer is represented in-file in little-endian
C       (least significant byte first). Read in the number:
        DO 10 I = 1, N
                  NUM = OR(NUM, ISHFT(ICHAR(TEMP(I)), 8*(I-1)))
   10   CONTINUE
       
C       Sign extend if necessary
        IF (SIGNED) THEN
C            Check whether or not the integer is negative
             IF (AND(NUM, ISHFT(1,BITS - 1)) .GT. 0) THEN
C               Set all higher bits
                NUM = OR(NUM, ISHFT(ISHFT(-1,-BITS),BITS))
             ENDIF
        ENDIF
        
        RETURN
      END   
 
