C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C       Get the number of the buffer containing
C       RECRD of file U. If no buffer exist,
C       create it.
        INTEGER FUNCTION GETREC(U,RECRD)
         IMPLICIT NONE
         INTEGER U,RECRD
         INTEGER LSTRES
         DATA LSTRES / 0 /
         SAVE LSTRES 
         INCLUDE "../../common/wav.f"
         INTEGER FNDBUF, LOADRC

C        Check if the last buffer we found is requested
C        again. This is highly likely, since
C        wav files are generally read/written sequentially
         IF (LSTRES .GT. 0 .AND. RECORD(1,LSTRES) .EQ. U .AND.
     +   RECORD(2,LSTRES) .EQ. RECRD) THEN
               GETREC = LSTRES
               RETURN 
         ENDIF

C        Find the buffer containing RECRD of U.
         GETREC = FNDBUF(U,RECRD)
C        If a buffer was not found, load the record into
C        a new buffer:
         IF (GETREC .EQ. 0) THEN
                 GETREC = LOADRC(U,RECRD)
         ENDIF

C        Mark the record as being most recently used,
C        unless it's already marked as most recently used
         IF (USED(GETREC) .EQ. 0 .OR. USED(GETREC) .NE. NXT - 1) THEN
              USED(GETREC) = NXT
              NXT = NXT + 1
         ENDIF

C        If NXT wraps around,
C        it's time to do something about the last
C        used array.

         IF (NXT .LE. 0) THEN
                CALL RSTORD
         ENDIF

C       Save the result. Mostly, we can reuse it
C       on the next call:
         LSTRES = GETREC
        RETURN
       END


