C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C        Now, NXT (number of next value to use in the USED() array=
C        might suddently become less than 0,
C        because we're dealing with finite representations of numbers.
C        If that happens, we need to shrink the gaps
C        between the numbers in the USED() values.

        SUBROUTINE RSTORD
          INTEGER I, N, LOWEST, LIDX
          INCLUDE "../../common/wav.f"

         IF (NBUFS .GT. 100) THEN
C         It's probably faster just to forget which buffers
C         were last used and start the counting over.
C         Very few extra READ's should ever comes of this,
C         taking much less time than sorting USED.
          DO 5 I = 1, NBUFS
                USED(I) = 0
    5     CONTINUE
          NXT = 1
          RETURN
         END IF 

C       The following code should probably be thrown away.

        LIDX = 1
C         We do not expect the number of buffers to be very large,
C         so a simple O(n^2) sort is in order here:
          DO 10 N = 0, NBUFS - 1
C               Set LOWEST to the highest possible value
                LOWEST = NXT - 1
C               Get the lowest nonnegative USED value and change it
                DO 20 I = 1, NBUFS
                     IF (LOWEST .LE. USED(I) .AND. USED(I) .GE. 0) THEN
                          LIDX = I
                          LOWEST = USED(I)
                     ENDIF
   20           CONTINUE
C               Set tempoary values in [-NBUFS : -1]
C               We require negative tempoary values,
C               cause USED(I) could be any nonnegative integer.
                USED(LIDX) = -NBUFS + N
   10     CONTINUE
         
C         Shift the tempoary indexs up to nonnegativevalues again
          DO 30 I = 1, NBUFS
                USED(I) = USED(I) + NBUFS
   30     CONTINUE
C         USED(I) is now in the range [0:NBUFS-1].

          NXT = NBUFS

          RETURN
        END


