C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Set string STR at position POS of length SLEN
C     in the file with unit number U.
      SUBROUTINE SETSTR(STR, U,POS,SLEN)
        IMPLICIT NONE
        INTEGER U, POS, SLEN, RECRD, BUFN, WRLEN
        INTEGER I, IDX, J
        CHARACTER STR(*)
        INCLUDE "../../common/wav.f"

        INTEGER GETREC

C       Find out what record to write to, and get the
C       corrosponding buffer
        RECRD = (POS - 1) / BUFLEN + 1 
        BUFN = GETREC(U,RECRD)
C       The GETREC request will or have been directly fed to READ(,)
C       so program execution stops on broken input, as it should!

C       IDX gives index of the start of the string in the buffer:
        IDX = MOD(POS - 1, BUFLEN) + 1
C       Copy SLEN bytes to buffer, unless
C       the buffer is too short.
        WRLEN = MIN(SLEN, BUFLEN - IDX + 1)
C       I is index of first uncopied char of STR.
        I = 1
   10   DO 15 J = 0, WRLEN - 1
           BUF(IDX+J,BUFN) = STR(I+J)
   15   CONTINUE
        DIRTY(BUFN) = .TRUE.

        IF (WRLEN + I - 1 .LT. SLEN) THEN
C         Not all of the string fits in the buffer.
C         Get buffer of next record and continue
          RECRD = RECRD + 1
          BUFN = GETREC(U,RECRD)
          IDX = 1
          I = I + WRLEN
          WRLEN = MIN(SLEN - I + 1, BUFLEN - IDX + 1)
          GOTO 10
        ENDIF
C       STR copied to file buffers

C       New file length:
        IF (POS+SLEN-1 .GT. DESCR(DESLEN,U)) THEN
                DESCR(DESLEN,U) = POS+SLEN-1
                CHGWLN(U) = .TRUE.
        ENDIF

        RETURN
      END


