C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     The opposite of SAM2PT: take a value between -1 and 1 and
C     convert to a wav sample.

      INTEGER FUNCTION PT2SAM(PT, BITS)
        REAL PT
        INTEGER BITS

C       Set samples larger than 1 to 1:
        IF (ABS(PT) .GT. 1.0) PT = PT/ABS(PT)

        IF (BITS .NE. 8) THEN
C               The maximum absolute sample value is 2^(BITS-1)
C               because we're dealing with signed integers
C               Add 0.5 before taking INT() to round up
                PT2SAM = INT(PT * (2**(BITS-1)-1) + 0.5)
        ELSE
C               We deal with unsigned integers, so
                PT2SAM = INT((PT*0.5 + 0.5)*(2**BITS - 1) + 0.5)
C               first make sample in [0:1], then [-0.5:0.5] and
C               finally [-1:1]
        ENDIF

        RETURN
      END

