C
C    Copyright (C) 2009 Anders Aspegren Søndergaard <andersas@gmail.com>
C    -------------------------------------------------------------------

C    This file is part of Wavlib.

C    Wavlib is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.

C    Wavlib is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with Wavlib. If not, see <http://www.gnu.org/licenses/>.


C     Set sample S, channel C of file U. It does not check
C     whether or not SMPLE fits into the file, but just
C     sets the least significant bits that fit into a sample size.
C     The routine does not check whether or not it writes outside
C     of the data subchunk.

      SUBROUTINE SETSAM(U,SMPLE, S, C)
        IMPLICIT NONE
        INTEGER U, S, C
        INTEGER SMPLE
        INTEGER POS, LENGTH,CHANLS,BITS
        INCLUDE "../../common/wav.f"

C       Bits per sample 
        BITS = DESCR(DESBPS,U)
 
C       One sample length
        LENGTH = BITS / 8
C       Number of channels
        CHANLS = DESCR(DESCNS,U)

        POS = DESCR(DESDAT,U)+8+LENGTH*CHANLS*(S-1)+(C-1)*LENGTH

C       Write the sample to file:
        CALL SETINT(SMPLE, U, POS, LENGTH)

        RETURN
      END


